#include <bits/stdc++.h>
using namespace std;

int main()
{
	long long n, k1, k2, rez=0, k=0;
	cin>>n;
	char c;
	long long a[n-1]={};
	char b[n-1];
	for(long long i=0; i<n-1; i++)
	{
		cin>>k1>>k2>>c;
		b[k1-1]=c;
	}
	for(long long i=0; i<n; i++)
	{
		while(b[i]=='S' && b[i+1]=='I' && b[i+2]=='O')
		{
			rez=rez+k+1;
			k++;
			i+=3;
		}
	}
	cout<<rez;
	return 0;
}